// ============================================================================
// Project:	Deductive Database
// Filename:	bench_j1axy_3.h
// Purpose:	Bottom-Up Evaluation for Join1, a(X,Y), Ver. 3 - static method
// Last Change:	21.05.2016
// Language:	C++
// EMail:	brass@informatik.uni-halle.de
// WWW:		http://www.informatik.uni-halle.de/~brass/
// Address:	Feldschloesschen 15, D-06120 Halle (Saale), GERMANY
// Copyright:	(c) 2015-2016 by Stefan Brass
// License:	See file "LICENSE" for copying conditions.
// Note:	There is no warranty at all - this code may contain bugs.
// ============================================================================


//=============================================================================
// Include File Frame:
//=============================================================================

#ifndef	BENCH_J1AXY_3_INCLUDED
#define BENCH_J1AXY_3_INCLUDED

//=============================================================================
// Used Types and Macros:
//=============================================================================

#ifndef VER_INCLUDED
#include "ver.h"
#endif

#ifndef STR_INCLUDED
#include "str.h"
#endif

#ifndef CHECK_INCLUDED
#include "check.h"
#endif

#ifndef PERF_INCLUDED
#include "perf.h"
#endif


//=============================================================================
// Bottom-Up Evaluation (Join 1 Benchmark: a(X,Y) - Ver. 3):
//=============================================================================

class bench_j1axy_3_c {

	//---------------------------------------------------------------------
	// This class has only static methods:
	//---------------------------------------------------------------------

	public:

	// run: Load data file, do bottom-up evaluation.
	static long run(str_t filename, perf_t timer_load, perf_t timer_eval);

	// name: Name of this benchmark.
	static str_t name() {
		return
		"Join 1, a(X,Y), Ver. 3: Relations in local vars, no dupcheck";
	}

	// file: List of data files.
	static str_t file(int i);

	// result: List of correct results of eval method.
	static long result(int i);

//-----------------------------------------------------------------------------
// Constructor, Destructor (Not Available):
//-----------------------------------------------------------------------------

	private:

	// Constructor:
	bench_j1axy_3_c(); // Not implemented

	// Destructor:
	~bench_j1axy_3_c(); // Not implemented


//-----------------------------------------------------------------------------
// Copy-constructor and assignment operator are not supported for this class:
//-----------------------------------------------------------------------------

	private:

	// These methods are not implemented:
	bench_j1axy_3_c(const bench_j1axy_3_c& obj);
	bench_j1axy_3_c& operator=(const bench_j1axy_3_c& obj);


//=============================================================================
// End of Class:
//=============================================================================

};


//=============================================================================
// End of Include File:
//=============================================================================

#endif

