// ============================================================================
// Project:	Deductive Database
// Filename:	bench_tcbf_1.h
// Purpose:	Bottom-Up Evaluation for Transitive Closure (bf) Example
// Last Change:	21.05.2016
// Language:	C++
// EMail:	brass@informatik.uni-halle.de
// WWW:		http://www.informatik.uni-halle.de/~brass/
// Address:	Feldschloesschen 15, D-06120 Halle (Saale), GERMANY
// Copyright:	(c) 2015-2016 by Stefan Brass
// License:	See file "LICENSE" for copying conditions.
// Note:	There is no warranty at all - this code may contain bugs.
// ============================================================================


//=============================================================================
// Include File Frame:
//=============================================================================

#ifndef	BENCH_TCBF_1_INCLUDED
#define BENCH_TCBF_1_INCLUDED

//=============================================================================
// Used Types and Macros:
//=============================================================================

#ifndef VER_INCLUDED
#include "ver.h"
#endif

#ifndef STR_INCLUDED
#include "str.h"
#endif

#ifndef CHECK_INCLUDED
#include "check.h"
#endif

#ifndef PERF_INCLUDED
#include "perf.h"
#endif


//=============================================================================
// Bottom-Up Evaluation (TC-ff Benchmark) - Class With Only Static Members:
//=============================================================================

class bench_tcbf_1_c {
	public:

//-----------------------------------------------------------------------------
// Static Methods:
//-----------------------------------------------------------------------------

	// run: Load data file, do bottom-up evaluation.
	static long run(str_t filename, perf_t timer_load, perf_t timer_eval);

	// name: Name of this benchmark.
	static str_t name() {
		return
		"tc(1,X), Ver. 1: SLDMagic, Rel.LocalVars, hand-crafted loader";
	}

	// file: List of data files.
	static str_t file(int i);

	// result: List of correct results of eval method.
	static long result(int i);


//-----------------------------------------------------------------------------
// This class has no objects:
//-----------------------------------------------------------------------------

	private:

	// Constructor:
	bench_tcbf_1_c();	// Not implemented

	// Destructor:
	~bench_tcbf_1_c();	// Not implemented

//-----------------------------------------------------------------------------
// Copy-constructor and assignment operator are not supported for this class:
//-----------------------------------------------------------------------------

	private:

	bench_tcbf_1_c(const bench_tcbf_1_c& obj);	// Not implemented
	bench_tcbf_1_c& operator=(const bench_tcbf_1_c& obj);// Not implemented


//=============================================================================
// End of Class:
//=============================================================================

};


//=============================================================================
// End of Include File:
//=============================================================================

#endif

