// ============================================================================
// Project:	Deductive Database
// Filename:	cur_2.h
// Purpose:	Cursor for list of rows with two int columns
// Last Change:	07.11.2015
// Language:	C++
// EMail:	brass@informatik.uni-halle.de
// WWW:		http://www.informatik.uni-halle.de/~brass/
// Address:	Feldschloesschen 15, D-06120 Halle (Saale), GERMANY
// Copyright:	(c) 2010-2015 by Stefan Brass
// License:	See file "LICENSE" for copying conditions.
// Note:	There is no warranty at all - this code may contain bugs.
// ============================================================================


//=============================================================================
// Include File Frame:
//=============================================================================

#ifndef	CUR_2_INCLUDED
#define CUR_2_INCLUDED

//=============================================================================
// Used Types and Macros:
//=============================================================================

#ifndef VER_INCLUDED
#include "ver.h"
#endif

#ifndef STR_INCLUDED
#include "str.h"
#endif

#ifndef CHECK_INCLUDED
#include "check.h"
#endif

#ifndef ROW_2_INCLUDED
#include "row_2.h"
#endif

#ifndef LIST_2_INCLUDED
#include "list_2.h"
#endif

#ifndef CUR_LIST_INCLUDED
#include "cur_list.h"
#endif


//=============================================================================
// Cursor over List of Rows with two int columns:
//=============================================================================

class cur_2_c: public cur_list_c<row_2_c> {

	public:

//-----------------------------------------------------------------------------
// Constructor, Destructor:
//-----------------------------------------------------------------------------

	// Constructor:
	cur_2_c(const list_2_c *list);

	// Destructor:
	~cur_2_c();

//-----------------------------------------------------------------------------
// Copy-constructor and assignment operator are not supported for this class:
//-----------------------------------------------------------------------------

	private:

	cur_2_c(const cur_2_c& obj);		// Not implemented
	cur_2_c& operator=(const cur_2_c& obj);	// Not implemented


//=============================================================================
// (Object) Methods:
//=============================================================================

	public:

//-----------------------------------------------------------------------------
// c1: Return value for column 1 of current row in cursor.
//-----------------------------------------------------------------------------

	inline int c1() {
		return cur_list_c<row_2_c>::row()->c1();
	}

//-----------------------------------------------------------------------------
// c2: Return value for column 2 of current row in cursor.
//-----------------------------------------------------------------------------

	inline int c2() {
		return cur_list_c<row_2_c>::row()->c2();
	}

//=============================================================================
// End of Class Template:
//=============================================================================

};


//-----------------------------------------------------------------------------
// Define pointer type:
//-----------------------------------------------------------------------------

typedef cur_2_c *cur_2_t;

//-----------------------------------------------------------------------------
// Define null pointer:
//-----------------------------------------------------------------------------

#define CUR_2_NULL (static_cast<cur_2_t>(0))


//=============================================================================
// End of Include File:
//=============================================================================

#endif

