// ============================================================================
// Project:	Deductive Database
// Filename:	list_1.h
// Purpose:	List of rows with one int column (relation with binding f)
// Last Change:	07.11.2015
// Language:	C++
// EMail:	brass@informatik.uni-halle.de
// WWW:		http://www.informatik.uni-halle.de/~brass/
// Address:	Feldschloesschen 15, D-06120 Halle (Saale), GERMANY
// Copyright:	(c) 2010-2015 by Stefan Brass
// License:	See file "LICENSE" for copying conditions.
// Note:	There is no warranty at all - this code may contain bugs.
// ============================================================================


//=============================================================================
// Include File Frame:
//=============================================================================

#ifndef	LIST_1_INCLUDED
#define LIST_1_INCLUDED

//=============================================================================
// Used Types and Macros:
//=============================================================================

#ifndef VER_INCLUDED
#include "ver.h"
#endif

#ifndef STR_INCLUDED
#include "str.h"
#endif

#ifndef CHECK_INCLUDED
#include "check.h"
#endif

#ifndef ROW_1_INCLUDED
#include "row_1.h"
#endif

#ifndef LIST_INCLUDED
#include "list.h"
#endif


//=============================================================================
// List of Rows with one int column / Relation with binding pattern b:
//=============================================================================

class list_1_c: public list_c<row_1_c> {

	public:

//-----------------------------------------------------------------------------
// Constructor, Destructor:
//-----------------------------------------------------------------------------

	// Constructor:
	list_1_c(str_t list_name);

	// Destructor:
	~list_1_c();

//-----------------------------------------------------------------------------
// Copy-constructor and assignment operator are not supported for this class:
//-----------------------------------------------------------------------------

	private:

	list_1_c(const list_1_c& obj);		// Not implemented
	list_1_c& operator=(const list_1_c& obj);	// Not implemented


//=============================================================================
// (Object) Methods:
//=============================================================================

	public:

//-----------------------------------------------------------------------------
// insert: Insert an element into the list (returns true if successful).
//-----------------------------------------------------------------------------

	inline bool insert(int col1) {
		return list_c<row_1_c>::insert(row_1_c(col1));
	}

//=============================================================================
// End of Class Template:
//=============================================================================

};


//-----------------------------------------------------------------------------
// Define pointer type:
//-----------------------------------------------------------------------------

typedef list_1_c *list_1_t;

//-----------------------------------------------------------------------------
// Define null pointer:
//-----------------------------------------------------------------------------

#define LIST_1_NULL (static_cast<list_1_t>(0))


//=============================================================================
// End of Include File:
//=============================================================================

#endif

