// ============================================================================
// Project:	Deductive Database
// Filename:	list_2.h
// Purpose:	List of rows with two int columns (relation with binding ff)
// Last Change:	07.11.2015
// Language:	C++
// EMail:	brass@informatik.uni-halle.de
// WWW:		http://www.informatik.uni-halle.de/~brass/
// Address:	Feldschloesschen 15, D-06120 Halle (Saale), GERMANY
// Copyright:	(c) 2010-2015 by Stefan Brass
// License:	See file "LICENSE" for copying conditions.
// Note:	There is no warranty at all - this code may contain bugs.
// ============================================================================


//=============================================================================
// Include File Frame:
//=============================================================================

#ifndef	LIST_2_INCLUDED
#define LIST_2_INCLUDED

//=============================================================================
// Used Types and Macros:
//=============================================================================

#ifndef VER_INCLUDED
#include "ver.h"
#endif

#ifndef STR_INCLUDED
#include "str.h"
#endif

#ifndef CHECK_INCLUDED
#include "check.h"
#endif

#ifndef ROW_2_INCLUDED
#include "row_2.h"
#endif

#ifndef LIST_INCLUDED
#include "list.h"
#endif


//=============================================================================
// List of Rows with two int columns / Relation with binding pattern ff:
//=============================================================================

class list_2_c: public list_c<row_2_c> {

	public:

//-----------------------------------------------------------------------------
// Constructor, Destructor:
//-----------------------------------------------------------------------------

	// Constructor:
	list_2_c(str_t list_name);

	// Destructor:
	~list_2_c();

//-----------------------------------------------------------------------------
// Copy-constructor and assignment operator are not supported for this class:
//-----------------------------------------------------------------------------

	private:

	list_2_c(const list_2_c& obj);		// Not implemented
	list_2_c& operator=(const list_2_c& obj);	// Not implemented


//=============================================================================
// (Object) Methods:
//=============================================================================

	public:

//-----------------------------------------------------------------------------
// insert: Insert an element into the list (returns true if successful).
//-----------------------------------------------------------------------------

	inline bool insert(int col1, int col2) {
		return list_c<row_2_c>::insert(row_2_c(col1, col2));
	}

//=============================================================================
// End of Class Template:
//=============================================================================

};


//-----------------------------------------------------------------------------
// Define pointer type:
//-----------------------------------------------------------------------------

typedef list_2_c *list_2_t;

//-----------------------------------------------------------------------------
// Define null pointer:
//-----------------------------------------------------------------------------

#define LIST_2_NULL (static_cast<list_2_t>(0))


//=============================================================================
// End of Include File:
//=============================================================================

#endif

